Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.c	(revision 387)
@@ -44,26 +44,5 @@
 #include "syssvc/syslog.h"
 #include "target_syssvc.h"
-#ifndef NTSHELL_NO_SOCKET
-#include <tinet_defs.h>
-#include <tinet_config.h>
-#include <net/net.h>
-#include <net/net_endian.h>
-#include <netinet/in.h>
-#include <netinet/in_itron.h>
-#include <tinet_nic_defs.h>
-#include <tinet_cfg.h>
-#include <netinet/in_var.h>
-#include <net/ethernet.h>
-#include <net/if6_var.h>
-#include <net/net.h>
-#include <net/if_var.h>
-#include <netinet/udp.h>
-#include <netinet/udp_var.h>
-#include <netinet/tcp.h>
-#include <netinet/tcp_var.h>
-#include <net/net_buf.h>
-#endif
-#include "ff.h"
-#include "socket_stub.h"
+#include "fdtable.h"
 #include "kernel_cfg.h"
 #include <string.h>
@@ -75,147 +54,14 @@
 #endif
 
-static int stdio_close(struct SHELL_FILE *fp);
-static size_t stdio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len);
-static size_t stdio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
-static size_t stdin_read(struct SHELL_FILE *fp, unsigned char *data, size_t len);
-static size_t stdout_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
-static size_t stderr_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
-static void stdio_delete(struct SHELL_FILE *fp);
-
-static int sio_close(struct SHELL_FILE *fp);
-static size_t sio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len);
-static size_t sio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
-static off_t sio_seek(struct SHELL_FILE *fp, off_t ofs, int org);
-static int sio_ioctl(struct SHELL_FILE *fp, int req, void *arg);
-static bool_t sio_readable(struct SHELL_FILE *fp);
-static void sio_delete(struct SHELL_FILE *fp);
-
-IO_TYPE IO_TYPE_STDIN = { stdio_close, stdin_read, stdio_write, sio_seek, sio_ioctl, sio_readable, stdio_delete };
-IO_TYPE IO_TYPE_STDOUT = { stdio_close, stdio_read, stdout_write, sio_seek, sio_ioctl, sio_readable, stdio_delete };
-IO_TYPE IO_TYPE_STDERR = { stdio_close, stdio_read, stderr_write, sio_seek, sio_ioctl, sio_readable, stdio_delete };
-IO_TYPE IO_TYPE_SIO = { sio_close, sio_read, sio_write, sio_seek, sio_ioctl, sio_readable, sio_delete };
-ntstdio_t ntstdio;
+extern IO_TYPE IO_TYPE_STDIN;
+extern IO_TYPE IO_TYPE_STDOUT;
+extern IO_TYPE IO_TYPE_STDERR;
 
 static struct SHELL_FILE fd_table[8 * sizeof(FLGPTN)] = {
-	{ 0, &IO_TYPE_STDIN, 0, .exinf = &ntstdio },
-	{ 1, &IO_TYPE_STDOUT, 0, .exinf = &ntstdio },
-	{ 2, &IO_TYPE_STDERR, 0,.exinf = &ntstdio },
+	{ STDIN_FILENO, &IO_TYPE_STDIN, 0 },
+	{ STDOUT_FILENO, &IO_TYPE_STDOUT, 0 },
+	{ STDERR_FILENO, &IO_TYPE_STDERR, 0 },
 };
 #define fd_table_count (sizeof(fd_table) / sizeof(fd_table[0]))
-
-extern ntstdio_t ntstdio;
-extern serial_t stdio_uart;
-
-unsigned char ntstdio_xi(struct ntstdio_t *handle)
-{
-	return serial_getc((serial_t *)handle->exinf);
-}
-
-void ntstdio_xo(struct ntstdio_t *handle, unsigned char c)
-{
-	serial_putc((serial_t *)handle->exinf, c);
-}
-
-void sys_init(intptr_t exinf)
-{
-	ntstdio_init(&ntstdio, NTSTDIO_OPTION_LINE_ECHO | NTSTDIO_OPTION_CANON | NTSTDIO_OPTION_LF_CRLF | NTSTDIO_OPTION_LF_CR, ntstdio_xi, ntstdio_xo);
-	ntstdio.exinf = (void *)&stdio_uart;
-}
-
-int stdio_close(struct SHELL_FILE *fp)
-{
-	return -EPERM;
-}
-
-size_t stdio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len)
-{
-	return -EPERM;
-}
-
-size_t stdio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
-{
-	return -EPERM;
-}
-
-size_t stdin_read(struct SHELL_FILE *fp, unsigned char *data, size_t len)
-{
-	int i = 0;
-	while (i < len) {
-		int c = ntstdio_getc((struct ntstdio_t *)fp->exinf);
-		data[i++] = c;
-		if ((c == EOF) || (c == '\n'))
-			break;
-	}
-	return i;
-}
-
-size_t stdout_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
-{
-	for (int i = 0; i < len; i++) {
-		ntstdio_putc((struct ntstdio_t *)fp->exinf, data[i]);
-	}
-	return len;
-}
-
-size_t stderr_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
-{
-	for (int i = 0; i < len; i++) {
-		ntstdio_putc((struct ntstdio_t *)fp->exinf, data[i]);
-	}
-	return len;
-}
-
-void stdio_delete(struct SHELL_FILE *fp)
-{
-}
-
-int sio_close(struct SHELL_FILE *fp)
-{
-	return -EPERM;
-}
-
-size_t sio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len)
-{
-	return -EPERM;
-}
-
-size_t sio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
-{
-	return -EPERM;
-}
-
-off_t sio_seek(struct SHELL_FILE *fp, off_t ofs, int org)
-{
-	return -EPERM;
-}
-
-int sio_ioctl(struct SHELL_FILE *fp, int request, void *arg)
-{
-	switch (request) {
-	case TIOCGWINSZ:
-		return 0;
-	case TCGETS:
-		return sio_tcgetattr(fp->fd, (struct termios *)arg);
-	case TCSETS + TCSANOW:
-	case TCSETS + TCSADRAIN:
-	case TCSETS + TCSAFLUSH:
-		return sio_tcsetattr(fp->fd, request - TCSETS, (const struct termios *)arg);
-	}
-
-	return -EINVAL;
-}
-
-bool_t sio_readable(struct SHELL_FILE *fp)
-{
-	return fp->readevt_w != fp->readevt_r;
-}
-
-void sio_delete(struct SHELL_FILE *fp)
-{
-	free((serial_t *)((struct ntstdio_t *)fp->exinf)->exinf);
-	((struct ntstdio_t *)fp->exinf)->exinf = NULL;
-	free((struct ntstdio_t *)fp->exinf);
-	fp->exinf = NULL;
-}
 
 struct SHELL_FILE *new_fp(IO_TYPE *type, int id, int writable)
@@ -245,4 +91,15 @@
 	if (ret < 0) {
 		syslog(LOG_ERROR, "sig_sem => %d", ret);
+	}
+
+	if (fp != NULL) {
+		FLGPTN flgptn = 0;
+
+		FD_SET(fp->fd, (fd_set *)&flgptn);
+
+		ret = clr_flg(FLG_SELECT_WAIT, ~flgptn);
+		if (ret != E_OK) {
+			syslog(LOG_ERROR, "clr_flg => %d", ret);
+		}
 	}
 
@@ -440,50 +297,9 @@
 }
 
-/* TODO:コールバック化したい */
-void stdio_update_evts()
-{
-	int fd = STDIN_FILENO;
-	struct SHELL_FILE *fp = &fd_table[fd];
-	FLGPTN flgptn = 0;
-
-	if (serial_readable((serial_t *)((struct ntstdio_t *)fp->exinf)->exinf)) {
-		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
-
-		FD_SET(fd, (fd_set *)&flgptn);
-	}
-	if (serial_writable((serial_t *)((struct ntstdio_t *)fp->exinf)->exinf)) {
-		if (fp->writeevt_w == fp->writeevt_r) fp->writeevt_w++;
-
-		FD_SET(fd, (fd_set *)&flgptn);
-	}
-
-	if (flgptn != 0) {
-		set_flg(FLG_SELECT_WAIT, flgptn);
-	}
-}
-
-/* TODO:コールバック化したい */
-void stdio_flgptn(FLGPTN *flgptn)
-{
-	int fd = STDIN_FILENO;
-	struct SHELL_FILE *fp = &fd_table[fd];
-	*flgptn = 0;
-
-	if (serial_readable((serial_t *)((struct ntstdio_t *)fp->exinf)->exinf)) {
-		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
-
-		FD_SET(fd, (fd_set *)flgptn);
-	}
-	if (serial_writable((serial_t *)((struct ntstdio_t *)fp->exinf)->exinf)) {
-		if (fp->writeevt_w == fp->writeevt_r) fp->writeevt_w++;
-
-		FD_SET(fd, (fd_set *)flgptn);
-	}
-}
-
 ER shell_get_evts(struct fd_events *evts, TMO tmout)
 {
 	int count = 0;
 	SYSTIM prev, now;
+	FLGPTN flgptn;
 
 	get_tim(&prev);
@@ -491,8 +307,6 @@
 	for (;;) {
 		ER ret;
-		FLGPTN waitptn, flgptn, readfds = 0, writefds = 0;
+		FLGPTN waitptn, readfds = 0, writefds = 0;
 		struct SHELL_FILE *fp = NULL;
-
-		stdio_update_evts();
 
 #ifndef NTSHELL_NO_SOCKET
@@ -504,5 +318,4 @@
 			fp = &fd_table[fd];
 
-#ifndef NTSHELL_NO_SOCKET
 			if (FD_ISSET(fd, &evts->readfds)) {
 				if (fp->type->readable(fp)) {
@@ -515,7 +328,7 @@
 				}
 			}
-#endif
+
 			if (FD_ISSET(fd, &evts->writefds)) {
-				if (fp->writeevt_w == fp->writeevt_r) {
+				if (fp->type->writable(fp)) {
 					FD_SET(fd, (fd_set *)&writefds);
 					count++;
@@ -547,46 +360,41 @@
 				return ret;
 			}
-
-			stdio_flgptn(&flgptn);
-
-			if (flgptn == 0)
-				return E_TMOUT;
-		}
-		flgptn &= waitptn;
-
-		/* 受け取ったフラグのみクリア */
-		ret = clr_flg(FLG_SELECT_WAIT, ~flgptn);
-		if (ret != E_OK) {
-			syslog(LOG_ERROR, "clr_flg => %d", ret);
+		}
+
+		if (flgptn != 0) {
+			flgptn &= waitptn;
+
+			/* 受け取ったフラグのみクリア */
+			ret = clr_flg(FLG_SELECT_WAIT, ~flgptn);
+			if (ret != E_OK) {
+				syslog(LOG_ERROR, "clr_flg => %d", ret);
+			}
 		}
 
 		count = 0;
 		for (int fd = 0; fd < fd_table_count; fd++) {
-			if (!FD_ISSET(fd, (fd_set *)&waitptn))
-				continue;
-
 			fp = &fd_table[fd];
 
 			if (fp->readevt_w != fp->readevt_r) {
 				fp->readevt_r++;
-				FD_SET(fd, &evts->readfds);
+				if (FD_ISSET(fd, (fd_set *)&waitptn))
+					FD_SET(fd, &evts->readfds);
 				count++;
 			}
 			if (fp->writeevt_w != fp->writeevt_r) {
 				fp->writeevt_r++;
-				fp->writable = 1;
-			}
-			if (fp->writable) {
-				FD_SET(fd, &evts->writefds);
+				if (FD_ISSET(fd, (fd_set *)&waitptn))
+					FD_SET(fd, &evts->writefds);
 				count++;
 			}
 			if (fp->errorevt_w != fp->errorevt_r) {
 				fp->errorevt_r++;
-				FD_SET(fd, &evts->errorfds);
+				if (FD_ISSET(fd, (fd_set *)&waitptn))
+					FD_SET(fd, &evts->errorfds);
 				count++;
 			}
 		}
 
-		if (count > 0)
+		if ((flgptn == 0) || (count > 0))
 			break;
 
@@ -594,6 +402,8 @@
 
 		SYSTIM elapse = now - prev;
-		if (elapse > tmout)
-			return E_TMOUT;
+		if (elapse > tmout) {
+			flgptn = 0;
+			break;
+		}
 
 		prev = now;
@@ -603,5 +413,5 @@
 	evts->count = count;
 
-	return E_OK;
+	return (flgptn == 0) ? E_TMOUT : E_OK;
 }
 
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.h	(revision 387)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/fdtable.h	(revision 387)
@@ -0,0 +1,85 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+#ifndef SOCKET_STUB_H
+#define SOCKET_STUB_H
+
+typedef const struct io_type_s IO_TYPE;
+
+struct SHELL_FILE {
+	int fd;
+	IO_TYPE *type;
+	int handle;
+	int readevt_r;
+	int readevt_w;
+	int writeevt_r;
+	int writeevt_w;
+	int writable;
+	int errorevt_r;
+	int errorevt_w;
+	void *exinf;
+};
+
+struct io_type_s {
+	int (*close)(struct SHELL_FILE *);
+	size_t (*read)(struct SHELL_FILE *, unsigned char *, size_t);
+	size_t (*write)(struct SHELL_FILE *, const unsigned char *, size_t);
+	off_t (*seek)(struct SHELL_FILE *, off_t, int);
+	int (*ioctl)(struct SHELL_FILE *, int, void *);
+	bool_t (*readable)(struct SHELL_FILE *);
+	bool_t (*writable)(struct SHELL_FILE *);
+	void (*delete)(struct SHELL_FILE *);
+};
+
+#ifndef bool
+#define bool int
+#endif
+#ifndef true
+#define true 1
+#endif
+#ifndef false
+#define false 0
+#endif
+
+struct SHELL_FILE *new_fp(IO_TYPE *type, int id, int writable);
+int delete_fd_by_id(IO_TYPE *type, int id);
+struct SHELL_FILE *fd_to_fp(int fd);
+struct SHELL_FILE *id_to_fd(IO_TYPE *type, int id);
+
+int delete_fp(struct SHELL_FILE *fp);
+void clean_fd();
+
+#endif // !SOCKET_STUB_H
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/io_stub.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/io_stub.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/io_stub.c	(revision 387)
@@ -45,5 +45,5 @@
 #include "syssvc/serial.h"
 #include "syssvc/syslog.h"
-#include "socket_stub.h"
+#include "fdtable.h"
 #include "util/ntstdio.h"
 #include "usrcmd.h"
@@ -51,4 +51,9 @@
 #include "kernel_cfg.h"
 #include "target_syssvc.h"
+
+struct SHELL_DIR {
+	FATFS_DIR dir;
+	struct dirent dirent;
+};
 
 int fresult2errno(FRESULT res)
@@ -85,4 +90,5 @@
 static int file_ioctl(struct SHELL_FILE *fp, int req, void *arg);
 static bool_t file_readable(struct SHELL_FILE *fp);
+static bool_t file_writable(struct SHELL_FILE *fp);
 static void file_delete(struct SHELL_FILE *fp);
 
@@ -93,8 +99,9 @@
 static int dir_ioctl(struct SHELL_FILE *fp, int req, void *arg);
 static bool_t dir_readable(struct SHELL_FILE *fp);
+static bool_t dir_writable(struct SHELL_FILE *fp);
 static void dir_delete(struct SHELL_FILE *fp);
 
-IO_TYPE IO_TYPE_FILE = { file_close, file_read, file_write, file_seek, file_ioctl, file_readable, file_delete };
-IO_TYPE IO_TYPE_DIR = { dir_close, dir_read, dir_write, dir_seek, dir_ioctl, dir_readable, dir_delete };
+IO_TYPE IO_TYPE_FILE = { file_close, file_read, file_write, file_seek, file_ioctl, file_readable, file_writable, file_delete };
+IO_TYPE IO_TYPE_DIR = { dir_close, dir_read, dir_write, dir_seek, dir_ioctl, dir_readable, dir_writable, dir_delete };
 
 int shell_open(const char *path, int flags, void *arg)
@@ -114,4 +121,5 @@
 		FRESULT res;
 		if ((res = f_opendir(dir, path)) != FR_OK) {
+			delete_fp(fp);
 			return fresult2errno(res);
 		}
@@ -165,4 +173,5 @@
 	}
 
+	delete_fp(fp);
 	return fresult2errno(res);
 }
@@ -239,4 +248,9 @@
 }
 
+bool_t file_writable(struct SHELL_FILE *fp)
+{
+	return fp->writable && (fp->writeevt_w == fp->writeevt_r);
+}
+
 void file_delete(struct SHELL_FILE *fp)
 {
@@ -356,84 +370,4 @@
 {
 	return shell_ioctl(fd, cmd, arg);
-}
-
-extern IO_TYPE IO_TYPE_SIO;
-
-int sio_tcgetattr(int fd, struct termios *termios)
-{
-	struct SHELL_FILE *fp = fd_to_fp(fd);
-	if ((fp == NULL) || (fp->type != &IO_TYPE_SIO))
-		return -EBADF;
-
-	ntstdio_t *ntstdio = (ntstdio_t *)fp->exinf;
-
-	memset(termios, 0, sizeof(*termios));
-
-	if (ntstdio->option & NTSTDIO_OPTION_LINE_ECHO) {
-		termios->c_lflag |= ECHO;
-	}
-	else {
-		termios->c_lflag &= ~ECHO;
-	}
-	if (ntstdio->option & NTSTDIO_OPTION_CANON) {
-		termios->c_lflag |= ICANON;
-	}
-	else {
-		termios->c_lflag &= ~ICANON;
-	}
-	if (ntstdio->option & NTSTDIO_OPTION_LF_CR) {
-		termios->c_iflag |= INLCR;
-	}
-	else {
-		termios->c_iflag &= ~INLCR;
-	}
-	if (ntstdio->option & NTSTDIO_OPTION_LF_CRLF) {
-		termios->c_oflag |= ONLCR;
-	}
-	else {
-		termios->c_oflag &= ~ONLCR;
-	}
-
-	return 0;
-}
-
-int sio_tcsetattr(int fd, int optional_actions, const struct termios *termios)
-{
-	struct SHELL_FILE *fp = fd_to_fp(fd);
-	if ((fp == NULL) || (fp->type != &IO_TYPE_SIO))
-		return -EBADF;
-
-	ntstdio_t *ntstdio = (ntstdio_t *)fp->exinf;
-
-	if (optional_actions == TCSANOW) {
-		if (termios->c_lflag & ECHO) {
-			ntstdio->option |= NTSTDIO_OPTION_LINE_ECHO;
-		}
-		else {
-			ntstdio->option &= ~NTSTDIO_OPTION_LINE_ECHO;
-		}
-		if (termios->c_lflag & ICANON) {
-			ntstdio->option |= NTSTDIO_OPTION_CANON;
-		}
-		else {
-			ntstdio->option &= ~NTSTDIO_OPTION_CANON;
-		}
-		if (termios->c_iflag & INLCR) {
-			ntstdio->option |= NTSTDIO_OPTION_LF_CR;
-		}
-		else {
-			ntstdio->option &= ~NTSTDIO_OPTION_LF_CR;
-		}
-		if (termios->c_oflag & ONLCR) {
-			ntstdio->option |= NTSTDIO_OPTION_LF_CRLF;
-		}
-		else {
-			ntstdio->option &= ~NTSTDIO_OPTION_LF_CRLF;
-		}
-		return 0;
-	}
-
-	shell_abort();
-	return 0;
 }
 
@@ -688,4 +622,9 @@
 }
 
+bool_t dir_writable(struct SHELL_FILE *fp)
+{
+	return false;
+}
+
 void dir_delete(struct SHELL_FILE *fp)
 {
@@ -710,40 +649,2 @@
 	return 0;
 }
-
-#ifndef _MSC_VER
-extern uint32_t __HeapBase;
-extern uint32_t __HeapLimit;
-#else
-uint8_t __HeapBase[14 * 4096];
-#define __HeapLimit __HeapBase[sizeof(__HeapBase)]
-#endif
-
-void *shell_brk(void *addr)
-{
-	if (addr == 0) {
-		return (void *)(&__HeapBase);
-	}
-	if ((addr >= (void *)&__HeapBase) && (addr < (void *)&__HeapLimit)) {
-		return addr;
-	}
-	return (void *)-1;
-}
-
-void *shell_mmap2(void *start, size_t length, int prot, int flags, int fd, off_t pgoffset)
-{
-	if (fd != -1)
-		return (void *)-EINVAL;
-
-	if ((length >= 0) && (length <= sizeof(&__HeapBase))) {
-		return &__HeapBase;
-	}
-	return (void *)-1;
-}
-
-int shell_mprotect(void *addr, size_t len, int prot)
-{
-	//if ((addr >= (void *)&__HeapBase) && (addr + len < (void *)&__HeapLimit)) {
-	return 0;
-//}
-//return -1;
-}
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/net_misc.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/net_misc.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/net_misc.c	(revision 387)
@@ -95,5 +95,5 @@
 
 	get_tid(&nc->tskid);
-	printf("[NET MISC:%d,%d] started.", nc->tskid, (ID)exinf);
+	syslog(LOG_NOTICE, "[NET MISC:%d,%d] started.", nc->tskid, (ID)exinf);
 
 	/* 初期化 */
@@ -103,5 +103,5 @@
 	ret = get_tim(&time);
 	if (ret != E_OK) {
-		printf("[NET MISC,%d] get_tim error: %7lu,%s",
+		syslog(LOG_NOTICE, "[NET MISC,%d] get_tim error: %7lu,%s",
 			nc->cepid, time / SYSTIM_HZ, itron_strerror(ret));
 		return;
@@ -117,5 +117,5 @@
 		error = tslp_tsk(timer);
 		if ((error != E_OK) && (error != E_TMOUT)) {
-			printf("[NET MISC,%d] tslp_tsk error: %s %d",
+			syslog(LOG_NOTICE, "[NET MISC,%d] tslp_tsk error: %s %d",
 				nc->cepid, itron_strerror(error), timer);
 			break;
@@ -124,5 +124,5 @@
 		ret = get_tim(&time);
 		if (ret != E_OK) {
-			printf("[NET MISC,%d] get_tim error: %s",
+			syslog(LOG_NOTICE, "[NET MISC,%d] get_tim error: %s",
 				nc->cepid, itron_strerror(ret));
 			break;
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/ntp_cli.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/ntp_cli.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/ntp_cli.c	(revision 387)
@@ -277,5 +277,5 @@
 	}
 
-	printf("[NTP CLI,%d] recv time: %s .%09u\n",
+	syslog(LOG_NOTICE, "[NTP CLI,%d] recv time: %s .%09u",
 		nc->cepid, nc->buf, tp.tv_nsec);
 }
@@ -309,5 +309,5 @@
 		line = lookup_ipaddr(&nc->ipaddr6, NTP_SRV_URL, API_PROTO_IPV4);
 		if (line == NULL || !in6_is_addr_ipv4mapped(&nc->ipaddr6)) {
-			printf("[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
+			syslog(LOG_NOTICE, "[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
 				nc->cepid, SLP_ITV / SYSTIM_HZ, SLP_ITV % SYSTIM_HZ);
 			nc->timer = SLP_ITV;
@@ -317,5 +317,5 @@
 #else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */
 		if ((line = lookup_ipaddr(&nc->snd_rmt.ipaddr, NTP_SRV_URL, DEFAULT_API_PROTO)) == NULL) {
-			printf("[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
+			syslog(LOG_NOTICE, "[NTP CLI,%d] sleep %d.%03u[s], unknown host.",
 				nc->cepid, SLP_ITV / SYSTIM_HZ, SLP_ITV % SYSTIM_HZ);
 			nc->timer = SLP_ITV;
@@ -421,10 +421,10 @@
 
 	if ((error = udp_snd_dat(nc->cepid, &nc->snd_rmt, ntp, len, TMO_NBLK)) != E_WBLK) {
-		printf("[NTP CLI,%d] udp_snd_dat error: %s",
+		syslog(LOG_NOTICE, "[NTP CLI,%d] udp_snd_dat error: %s",
 			nc->cepid, itron_strerror(error));
 		return error;
 	}
 	else
-		syslog(LOG_DEBUG, "[NTP CLI,%d] udp_snd_dat: to: %s.%d\n",
+		syslog(LOG_DEBUG, "[NTP CLI,%d] udp_snd_dat: to: %s.%d",
 			nc->cepid, ip2str(NULL, &nc->snd_rmt.ipaddr), nc->snd_rmt.portno);
 
@@ -439,5 +439,5 @@
 	ret = get_tim(&time);
 	if (ret != E_OK) {
-		printf("[NTP CLI,%d] get_tim error: %s",
+		syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %s",
 			nc->cepid, itron_strerror(ret));
 		tp->tv_sec = 0;
@@ -459,5 +459,5 @@
 	ret = set_tim(time);
 	if (ret != E_OK) {
-		printf("[NTP CLI,%d] set_tim error: %s",
+		syslog(LOG_NOTICE, "[NTP CLI,%d] set_tim error: %s",
 			nc->cepid, itron_strerror(ret));
 	}
@@ -477,5 +477,5 @@
 	if (len < 0 && len != E_RLWAI) {
 		/* E_RLWAI 以外で、0 以下の場合は、エラーを意味している。*/
-		printf("[NTP CLI,%d] callback error: %s, fncd: %s", nc->cepid,
+		syslog(LOG_NOTICE, "[NTP CLI,%d] callback error: %s, fncd: %s", nc->cepid,
 			itron_strerror(len), in_strtfn(fncd));
 	}
@@ -484,5 +484,5 @@
 			if ((len = udp_rcv_dat(nc->cepid, &nc->rcv_rmt, &nc->ntp_msg, len, TMO_POL)) < 0)
 			{
-				printf("[NTP CLI,%d] udp_rcv_dat error: %s", nc->cepid,
+				syslog(LOG_NOTICE, "[NTP CLI,%d] udp_rcv_dat error: %s", nc->cepid,
 					itron_strerror(len));
 			}
@@ -516,5 +516,5 @@
 
 	get_tid(&nc->tskid);
-	printf("[NTP CLI:%d,%d] started.", nc->tskid, (ID)exinf);
+	syslog(LOG_NOTICE, "[NTP CLI:%d,%d] started.", nc->tskid, (ID)exinf);
 
 	/* 初期化 */
@@ -523,5 +523,5 @@
 	ret = get_tim(&time);
 	if (ret != E_OK) {
-		printf("[NTP CLI,%d] get_tim error: %7lu,%s",
+		syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %7lu,%s",
 			nc->cepid, time / SYSTIM_HZ, itron_strerror(ret));
 		return;
@@ -537,5 +537,5 @@
 		error = tslp_tsk(timer);
 		if ((error != E_OK) && (error != E_TMOUT)) {
-			printf("[NTP CLI,%d] tslp_tsk error: %s %d",
+			syslog(LOG_NOTICE, "[NTP CLI,%d] tslp_tsk error: %s %d",
 				nc->cepid, itron_strerror(error), timer);
 			break;
@@ -544,5 +544,5 @@
 		ret = get_tim(&time);
 		if (ret != E_OK) {
-			printf("[NTP CLI,%d] get_tim error: %s",
+			syslog(LOG_NOTICE, "[NTP CLI,%d] get_tim error: %s",
 				nc->cepid, itron_strerror(ret));
 			break;
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell.cdl
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell.cdl	(revision 387)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell.cdl	(revision 387)
@@ -0,0 +1,79 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2015 by Ushio Laboratory
+ *              Graduate School of Engineering Science, Osaka Univ., JAPAN
+ *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+import_C("target_syssvc.h");
+
+/*
+ *  タスクのスタックサイズのデフォルト
+ */
+const size_t DefaultTaskStackSize = 1024;		/* スタックサイズ（1KB）*/
+
+/*
+ *  システムログタスクのスタックサイズの定義
+ */
+const size_t LogTaskStackSize = DefaultTaskStackSize;
+
+/*
+ *  カーネル起動メッセージに関する定義
+ */
+const char *const BannerTargetName = C_EXP("TARGET_NAME");		/* ターゲット名 */
+const char *const BannerCopyrightNotice = "";			/* 著作権表示 */
+
+/*
+ *  ターゲット依存のセルタイプの定義
+ */
+import("syssvc/tPutLogSIOPort.cdl");
+import("tSIOPortNTShell.cdl");
+
+/*
+ *  シリアルインタフェースドライバのターゲット依存部の組み上げ記述
+ */
+cell tSIOPortNTShell SIOPortTarget1 {
+};
+
+/*
+ *  低レベル出力の組み上げ記述
+ */
+cell tPutLogSIOPort PutLogTarget {
+	/* SIOドライバとの結合 */
+	cSIOPort = SIOPortTarget1.eSIOPort;
+};
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell_main.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell_main.c	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/ntshell_main.c	(revision 387)
@@ -58,5 +58,5 @@
 #include "util/ntopt.h"
 #include "ntshell_main.h"
-#include "socket_stub.h"
+#include "fdtable.h"
 
 char command[NTOPT_TEXT_MAXLEN];
@@ -78,4 +78,5 @@
 }
 
+void stdio_open(ID portid);
 static int usrcmd_ntopt_callback(long *args, void *extobj);
 
@@ -86,5 +87,5 @@
 void ntshell_task_init(ID portid)
 {
-	serial_ctl_por(portid, IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV);
+	stdio_open(portid);
 }
 
@@ -95,5 +96,12 @@
 {
 	ntshell_state = 1;
-	ntshell_exit_code = ntopt_parse(command, usrcmd_ntopt_callback, NULL);
+
+	if (setjmp(process_exit) == 0) {
+		ntshell_exit_code = ntopt_parse(command, usrcmd_ntopt_callback, NULL);
+	}
+
+	fflush(stdout);
+	clean_fd();
+
 	ntshell_state = 2;
 }
@@ -139,6 +147,4 @@
 		printf("Unknown command found.\n");
 
-	clean_fd();
-
 	return result;
 }
@@ -285,9 +291,18 @@
 }
 
-struct sigaction sigtable[7];
-
-int shell_sigaction(int sig, const struct sigaction *restrict sa, struct sigaction *restrict old)
-{
-	struct sigaction *sat;
+// musl-1.1.18\src\internal\ksigaction.h
+struct k_sigaction {
+	void(*handler)(int);
+	unsigned long flags;
+	void(*restorer)(void);
+	unsigned mask[2];
+};
+
+struct k_sigaction sigtable[7];
+
+int shell_sigaction(int sig, const struct k_sigaction *__restrict sa,
+	struct k_sigaction *__restrict old, size_t size)
+{
+	struct k_sigaction *sat;
 
 	switch(sig){
@@ -318,7 +333,7 @@
 
 	if (old != NULL)
-		memcpy(old, sat, sizeof(struct sigaction));
-
-	memcpy(sat, sa, sizeof(struct sigaction));
+		memcpy(old, sat, offsetof(struct k_sigaction, mask) + size);
+
+	memcpy(sat, sa, offsetof(struct k_sigaction, mask) + size);
 
 	return 0;
@@ -368,2 +383,34 @@
 }
 
+int shell_nanosleep(const struct timespec *req, struct timespec *rem)
+{
+	ER ret;
+	TMO tmo;
+	SYSTIM prev, now, diff;
+
+	if ((req == NULL) || (req->tv_nsec < 0) || (req->tv_nsec >= 1000000000))
+		return -EINVAL;
+
+	get_tim(&prev);
+
+	tmo = req->tv_sec * 1000000 + req->tv_nsec / 1000;
+	ret = tslp_tsk(tmo);
+	if (ret == E_OK) {
+		if (rem != NULL) {
+			get_tim(&now);
+			diff = now - prev;
+			rem->tv_sec = diff / 1000000ll;
+			rem->tv_nsec = (diff - (rem->tv_sec * 1000000ll)) * 1000ll;
+		}
+		return 0;
+	}
+	else if (ret == E_TMOUT) {
+		if (rem != NULL) {
+			rem->tv_sec = 0;
+			rem->tv_nsec = 0;
+		}
+		return 0;
+	}
+
+	return -EFAULT;
+}
Index: asp3_tinet_ecnl_arm/trunk/ntshell/src/shellif.h
===================================================================
--- asp3_tinet_ecnl_arm/trunk/ntshell/src/shellif.h	(revision 380)
+++ asp3_tinet_ecnl_arm/trunk/ntshell/src/shellif.h	(revision 387)
@@ -74,7 +74,7 @@
 #define NCCS 32
 
-#include <bits/fcntl.h>
-#include <bits/termios.h>
-#include <bits/stat.h>
+#include <fcntl.h>
+#include <termios.h>
+#include <sys/stat.h>
 #include <sys/select.h>
 #include <time.h>
@@ -85,6 +85,6 @@
 #include <sys/utsname.h>
 #include <dirent.h>
-#include <bits/ioctl.h>
-#include <bits/errno.h>
+#include <sys/ioctl.h>
+#include <errno.h>
 #include <sys/socket.h>
 #else
@@ -132,4 +132,5 @@
 // time.h
 #define CLOCK_REALTIME 0
+int shell_nanosleep(const struct timespec *req, struct timespec *rem);
 
 // dirent.h
@@ -177,5 +178,7 @@
 // signal.h
 int shell_sigprocmask(int how, const sigset_t *__restrict set, sigset_t *__restrict old);
-int shell_sigaction(int sig, const struct sigaction *__restrict sa, struct sigaction *__restrict old);
+struct k_sigaction;
+int shell_sigaction(int sig, const struct k_sigaction *__restrict sa,
+	struct k_sigaction *__restrict old, size_t size);
 // socket.h
 int shell_socket(int, int, int);
@@ -197,7 +200,4 @@
 // syslog.h
 void vsyslog (int, const char *, va_list);
-// termios.h
-int sio_tcgetattr (int, struct termios *);
-int sio_tcsetattr(int, int, const struct termios *);
 // fcntl.h
 int shell_open(const char *, int, void *arg);
